%define section free
# The plugin builds successfully as of jswat 2.20 and jedit 4.2pre9
%define with_jedit %{?_with_jedit:1}%{!?_with_jedit:0}

Summary:        Graphical Java debugger
Name:           jswat
Version:        2.20
Release:        1jpp
Epoch:          0
Group:          Development/Debuggers
License:        GPL
URL:            http://www.bluemarsh.com/java/jswat/
Source0:        http://download.sf.net/jswat/jswat-src-2.20.tar.gz
Source1:        %{name}.sh
# convert classes/com/bluemarsh/jswat/ui/resources/housefly.gif jswat-48.png
Source2:        %{name}-48.png
Source3:        %{name}.desktop
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Vendor:         JPackage Project
Distribution:   JPackage

BuildArch:      noarch
Requires:       jclasslib
Requires:       jpackage-utils >= 0:1.5
BuildRequires:  ant
BuildRequires:  jclasslib
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  sablecc
%if %{with_jedit}
# aelfred pulled in by jedit
BuildRequires:  aelfred
BuildRequires:  jedit
%endif

%description
JSwat is a standalone, graphical Java debugger front-end, written to
use the Java Platform Debugger Architecture (JPDA) library provided by
JavaSoft.

Features include breakpoints with conditionals and monitors; colorized
source code display; graphical display panels showing threads, stack
frames, visible variables, and loaded classes; command interface for
more advanced features; and Java-like expression evaluation.

%package        mdkmenu
Summary:        Mandrake menu entry for %{name}
Group:          Development/Tools
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    mdkmenu
This is a Mandrake menu system entry for %{name}.

%package     -n jedit-%{name}
Summary:        JSwat plugin for jEdit
Group:          Development/Tools
Requires:       %{name} = %{epoch}:%{version}-%{release}, jedit

%description -n jedit-%{name}
%{summary}.


%prep
%setup -q
find -name "*.jar" -exec rm -f {} ';'
# No Class-Path, please.
perl -pi -e 's/^.*Class-Path.*[\r\n]*$//' build.xml


%build

cd parser
CLASSPATH=%(build-classpath sablecc) ant
cd -

export CLASSPATH=`pwd`/parser/parser.jar:%(build-classpath jclasslib)
# Tests would require a GUI...
echo %{version} | ant binjar

%if %{with_jedit}
export CLASSPATH=$CLASSPATH:%(build-classpath jedit aelfred)
cd plugins/jedit
echo %{version} | ant binjar
cd -
%endif


%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/dist/%{name}-%{version}/%{name}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
cp -p parser/parser.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-parser-%{version}.jar
ln -s %{name}-parser-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-parser.jar

# scripts
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}

# freedesktop.org menu entry
mkdir -p $RPM_BUILD_ROOT%{_datadir}/{applications,pixmaps}
cp -p %{SOURCE3} \
  $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}.desktop
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/pixmaps/%{name}.png

%if %{with_jedit}
# TODO: jedit
%endif

# mdk menu entry
mkdir -p $RPM_BUILD_ROOT{%{_menudir},%{_miconsdir}}
cat >$RPM_BUILD_ROOT%{_menudir}/%{name} <<EOF
?package(jswat):\\
command="%{_bindir}/%{name}"\\
needs="X11"\\
icon="%{name}.png"\\
section="Applications/Development/Tools"\\
title="JSwat" \
longtitle="Graphical Java debugger"
EOF
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_iconsdir}/%{name}.png


%clean
rm -rf $RPM_BUILD_ROOT


%post mdkmenu
%update_menus

%postun mdkmenu
%clean_menus


%files
%defattr(0644,root,root,0755)
%doc *.txt *.html
%{_javadir}/%{name}*.jar
%attr(0755,root,root) %{_bindir}/%{name}
%{_datadir}/applications/*%{name}.desktop
%{_datadir}/pixmaps/%{name}.png

%files mdkmenu
%defattr(0644,root,root,0755)
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png

%if %{with_jedit}
%files -n jedit-%{name}
%defattr(0644,root,root,0755)
# TODO
%endif

%changelog
* Sat Feb 14 2004 David Walluck <david@anti-microsoft.org> 0:2.20-1jpp
- 2.20
- build jedit plugin
- change mdkmenu menu group to Development/Tools

* Tue Jan 13 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.19-2jpp
- Require jclasslib.
- Update startup script.

* Sat Jan 10 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.19-1jpp
- Update to 2.19.
- Update desktop entry and icon.

* Wed Sep 24 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.17-1jpp
- Update to 2.17.
- Save .spec in UTF-8, some cleanups.

* Fri Apr 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.15-1jpp
- Update to 2.15 and JPackage 1.5.
- Drop javadocs (target no more included in build.xml).
- Spec file cleanups.

* Fri Aug  2 2002 Ville Skyttä <ville.skytta at iki.fi> 1.6-3jpp
- Clean up startup script, thanks to Nathan Fiedler (author).

* Thu Aug  1 2002 Ville Skyttä <ville.skytta at iki.fi> 1.6-2jpp
- Use java-functions in startup script if available.
- Add Mandrake and Red Hat menu items.
- Add -Dbuild.compiler=modern to ant build options.

* Wed Jul 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.6-1jpp
- jswat 1.6

* Fri Jun 07 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.4-1jpp
- jswat 1.4
- Initial jpackage release
- built with IBM SDK 1.3.1 since I've got problems at startup when
  built with jikes 1.15 ('Expecting to find object/array on stack')
